import { ref } from 'vue';
import { defineStore } from 'pinia';
import {
  addTrajectory,
  addImagePoint,
  addPoint,
  closePoint,
  playTrajectory,
  startBidding
} from '@/utils/map/mapOperation.js';

export const useMapStore = defineStore('mapStore', () => {
  //当前图例高亮图标列表
  const currentToolSelectArray = ref(['newAdress', 'touch']);

  //点亮地图工具图标
  const setCurrentToolSelectArray = (value) => {
    currentToolSelectArray.value.push(value);
    switch (value) {
      case 'newAdress': {
        //新址图标
        addPoint(value);
        break;
      }
      case 'touch': {
        //密接图标
        addImagePoint(value, {
          imageUrl: new URL(`@/assets/image/mapTools/2.png`, import.meta.url).href
        });
        break;
      }
      case 'infectious': {
        //传染病图标
        addPoint(value);
        break;
      }
      case 'feverClinic': {
        //发热门诊图标
        addPoint(value);
        break;
      }
      case 'breathe': {
        //呼吸图标
        addPoint(value);
        break;
      }
      case 'flowCar': {
        //流调会商车图标
        addTrajectory();
        setTimeout(() => {
          playTrajectory();
        }, 1000);
        break;
      }
      case 'Bidding': {
        //标会工具
        startBidding(false);
        break;
      }
    }
  };

  //关闭地图工具图标
  const delCurrentToolSelectArray = (value) => {
    currentToolSelectArray.value = currentToolSelectArray.value.filter((item) => item != value);
    if (value == 'Bidding') {
      startBidding(false);
    } else {
      closePoint(value);
    }
  };

  return { currentToolSelectArray, setCurrentToolSelectArray, delCurrentToolSelectArray };
});
